/*
  Java gfx-test framework

   Copyright (C) 2010, 2011  Red Hat

This file is part of IcedTea.

IcedTea is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

IcedTea is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with IcedTea; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version.
 */

package org.gfxtest.testsuites;



import org.gfxtest.framework.GfxTest;
import org.gfxtest.framework.annotations.TestType;
import org.gfxtest.framework.annotations.TestTypes;
import org.gfxtest.framework.annotations.Transformation;
import org.gfxtest.framework.annotations.Transformations;
import org.gfxtest.framework.annotations.Zoom;



/**
 * This test check if clipping is working correctly for various types of clips
 * and various types of rendered shapes.
 * 
 * @author Pavel Tisnovsky
 */
@TestType(TestTypes.RENDER_TEST)
@Transformation(Transformations.NONE)
@Zoom(1)
public class Clipping extends GfxTest
{

    /**
     * Check if circle shape could be clipped by a rectangle. Circle is rendered
     * using stroke paint.
     * 
     * @param image
     *            work image
     * @param graphics2d
     *            graphics canvas
     * @return test result status - PASSED, FAILED or ERROR
     */
    /*
    public TestResult testClipCircleByRectangleShapeStrokePaint(TestImage image, Graphics2D graphics2d)
    {
        // render clip rectangle
        renderClipRectangle(image, graphics2d);
        // set stroke color
        CommonRenderingStyles.setStrokeColor(graphics2d);
        // create clip area
        createClipUsingRectangleShape(image, graphics2d);
        // draw the area
        CommonShapesRenderer.drawCircle(image, graphics2d);
        // test result
        return TestResult.PASSED;
    }
    */

    /**
     * Check if circle shape could be clipped by a rounded rectangle. Circle is
     * rendered using stroke paint.
     * 
     * @param image
     *            work image
     * @param graphics2d
     *            graphics canvas
     * @return test result status - PASSED, FAILED or ERROR
     */
    /*
    public TestResult testClipCircleByRoundedRectangleShapeStrokePaint(TestImage image, Graphics2D graphics2d)
    {
        // render clip rectangle
        renderClipRectangle(image, graphics2d);
        // render clip rectangle
        renderClipRoundRectangle(image, graphics2d);
        // set stroke color
        CommonRenderingStyles.setStrokeColor(graphics2d);
        // create clip area
        createClipUsingRoundRectangleShape(image, graphics2d);
        // draw the area
        CommonShapesRenderer.drawCircle(image, graphics2d);
        // test result
        return TestResult.PASSED;
    }
    */

    /**
     * Check if circle shape could be clipped by a ellipse. Circle is rendered
     * using stroke paint.
     * 
     * @param image
     *            work image
     * @param graphics2d
     *            graphics canvas
     * @return test result status - PASSED, FAILED or ERROR
     */
    /*
    public TestResult testClipCircleByEllipseShapeStrokePaint(TestImage image, Graphics2D graphics2d)
    {
        // render clip rectangle
        renderClipRectangle(image, graphics2d);
        // and also clip ellipse
        renderClipEllipse(image, graphics2d);
        // set stroke color
        CommonRenderingStyles.setStrokeColor(graphics2d);
        // create clip area
        createClipUsingEllipseShape(image, graphics2d);
        // draw the area
        CommonShapesRenderer.drawCircle(image, graphics2d);
        // test result
        return TestResult.PASSED;
    }*/

    /**
     * Entry point to the test suite.
     * 
     * @param args
     *            graphics test configuration
     */
    public static void main(String[] args)
    {
        new Clipping().runTestSuite(args);
    }
}
